package io.awesome.gagtube.fragments.library;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import androidx.activity.result.ActivityResultLauncher;
import androidx.activity.result.contract.ActivityResultContracts;
import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.viewpager.widget.ViewPager;

import com.bumptech.glide.Glide;
import com.bumptech.glide.load.engine.DiskCacheStrategy;
import com.google.android.gms.auth.api.signin.GoogleSignIn;
import com.google.android.gms.auth.api.signin.GoogleSignInAccount;
import com.google.android.gms.auth.api.signin.GoogleSignInClient;
import com.google.android.gms.auth.api.signin.GoogleSignInOptions;
import com.google.android.gms.common.api.ApiException;
import com.google.android.gms.tasks.Task;
import com.google.android.material.tabs.TabLayout;
import com.google.firebase.auth.AuthCredential;
import com.google.firebase.auth.FirebaseAuth;
import com.google.firebase.auth.GoogleAuthProvider;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;
import de.hdodenhof.circleimageview.CircleImageView;
import io.awesome.gagtube.R;
import io.awesome.gagtube.base.BaseFragment;
import io.awesome.gagtube.util.AppUtils;
import io.awesome.gagtube.util.NavigationHelper;
import io.awesome.gagtube.util.ServiceHelper;
import io.awesome.gagtube.util.SharedPrefsHelper;
import io.awesome.gagtube.util.dialog.AccountInfoDialog;
import io.awesome.gagtube.util.dialog.DialogUtils;

public class LibraryFragment extends BaseFragment {

    public static LibraryFragment getInstance() {
        return new LibraryFragment();
    }

    @BindView(R.id.tabLayout)
    TabLayout tabLayout;
    @BindView(R.id.viewPager)
    ViewPager viewPager;
    @BindView(R.id.status_bar)
    View statusBarView;

    private LibraryViewPagerAdapter adapter;

//    @BindView(R.id.user_avatar)
//    CircleImageView userAvatar;
//    private GoogleSignInClient mGoogleSignInClient;
//    private FirebaseAuth mAuth;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        adapter = new LibraryViewPagerAdapter(getChildFragmentManager(), activity);

//        // Configure sign-in to request the user's ID, email address, and basic
//        // profile. ID and basic profile are included in DEFAULT_SIGN_IN.
//        GoogleSignInOptions gso = new GoogleSignInOptions.Builder(GoogleSignInOptions.DEFAULT_SIGN_IN)
//                .requestIdToken(getString(R.string.client_id))
//                .requestEmail()
//                .build();
//
//        // Build a GoogleSignInClient with the options specified by gso.
//        mGoogleSignInClient = GoogleSignIn.getClient(activity, gso);
//
//        // Initialize Firebase Auth
//        mAuth = FirebaseAuth.getInstance();
    }

    @Override
    public void onStart() {
        super.onStart();
        // Check for existing Google Sign In account, if the user is already signed in
        // the GoogleSignInAccount will be non-null.
//        GoogleSignInAccount account = GoogleSignIn.getLastSignedInAccount(activity);
//        updateUI(account);
    }

//    public void updateUI(GoogleSignInAccount account) {
//        if (account != null) {
//            Glide.with(activity).load(account.getPhotoUrl())
//                    .diskCacheStrategy(DiskCacheStrategy.ALL)
//                    .placeholder(R.drawable.ic_account_circle_white_24dp)
//                    .error(R.drawable.ic_account_circle_white_24dp)
//                    .fallback(R.drawable.ic_account_circle_white_24dp)
//                    .into(userAvatar);
//
//            AuthCredential credential = GoogleAuthProvider.getCredential(account.getIdToken(), null);
//            mAuth.signInWithCredential(credential)
//                    .addOnCompleteListener(activity, task -> {
//                    });
//        } else {
//            Glide.with(activity).load(R.drawable.ic_account_circle_white_24dp)
//                    .diskCacheStrategy(DiskCacheStrategy.ALL)
//                    .placeholder(R.drawable.ic_account_circle_white_24dp)
//                    .error(R.drawable.ic_account_circle_white_24dp)
//                    .fallback(R.drawable.ic_account_circle_white_24dp)
//                    .into(userAvatar);
//        }
//    }
//
//    @OnClick(R.id.user_avatar)
//    void onUserAvatarClicked() {
//        GoogleSignInAccount account = GoogleSignIn.getLastSignedInAccount(activity);
//        if (account != null) {
//            AccountInfoDialog accountInfoDialog = AccountInfoDialog.getInstance(account, mGoogleSignInClient, () -> {
//                updateUI(null);
//                SharedPrefsHelper.removePrefs(activity, SharedPrefsHelper.Key.USER_LOGIN_EMAIL.name());
//            });
//            accountInfoDialog.show(getFM(), AccountInfoDialog.class.getSimpleName());
//        } else {
//            boolean showedLoginDialog = SharedPrefsHelper.getBooleanPrefs(activity, SharedPrefsHelper.Key.SHOWED_LOGIN_DIALOG.name());
//            if (showedLoginDialog) {
//                signIn();
//            } else {
//                DialogUtils.showLoginDialog(activity, (dialogInterface, i) -> signIn(), (dialogInterface, i) -> dialogInterface.dismiss());
//            }
//        }
//    }
//
//    private void signIn() {
//        Intent signInIntent = mGoogleSignInClient.getSignInIntent();
//        mStartForResult.launch(signInIntent);
//    }
//
//    ActivityResultLauncher<Intent> mStartForResult = registerForActivityResult(new ActivityResultContracts.StartActivityForResult(), result -> {
//        if (result.getResultCode() == Activity.RESULT_OK) {
//            Intent data = result.getData();
//            // Handle the Intent
//            Task<GoogleSignInAccount> task = GoogleSignIn.getSignedInAccountFromIntent(data);
//            handleSignInResult(task);
//        }
//        if (result.getResultCode() == Activity.RESULT_CANCELED) {
//            Intent data = result.getData();
//            // Handle the Intent
//            Task<GoogleSignInAccount> task = GoogleSignIn.getSignedInAccountFromIntent(data);
//            handleSignInResult(task);
//        }
//    });
//
//    private void handleSignInResult(Task<GoogleSignInAccount> completedTask) {
//        try {
//            GoogleSignInAccount account = completedTask.getResult(ApiException.class);
//            // Save user's email logged in
//            SharedPrefsHelper.setStringPrefs(activity, SharedPrefsHelper.Key.USER_LOGIN_EMAIL.name(), account.getEmail());
//            SharedPrefsHelper.setBooleanPrefs(activity, SharedPrefsHelper.Key.SHOWED_LOGIN_DIALOG.name(), true);
//            // Signed in successfully, show authenticated UI.
//            updateUI(account);
//        } catch (ApiException e) {
//            // The ApiException status code indicates the detailed failure reason.
//            // Please refer to the GoogleSignInStatusCodes class reference for more information.
//            updateUI(null);
//        }
//    }

    @Nullable
    @Override
    public View onCreateView(@NonNull LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
        View view = inflater.inflate(R.layout.fragment_library, container, false);
        ButterKnife.bind(this, view);
        return view;
    }

    @Override
    protected void initViews(View rootView, Bundle savedInstanceState) {
        super.initViews(rootView, savedInstanceState);
        AppUtils.setStatusBarHeight(activity, statusBarView);
        initAdapter();
    }

    private void initAdapter() {
        // set adapter to viewPager
        viewPager.setAdapter(adapter);
        // setup tabLayout with viewPager
        tabLayout.setupWithViewPager(viewPager);
    }

    @OnClick(R.id.action_search)
    void onSearch() {
        // open search
        NavigationHelper.openSearchFragment(getFM(), ServiceHelper.getSelectedServiceId(activity), "");
    }

    @OnClick(R.id.action_settings)
    void onSettings() {
        // open Settings
        NavigationHelper.openSettings(activity);
    }
}
