package io.awesome.gagtube.fragments.songs;

import android.content.Context;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.fragment.app.Fragment;
import androidx.fragment.app.FragmentManager;
import androidx.fragment.app.FragmentStatePagerAdapter;
import androidx.lifecycle.Lifecycle;
import androidx.viewpager2.adapter.FragmentStateAdapter;

import org.jetbrains.annotations.NotNull;

import io.awesome.gagtube.R;
import io.awesome.gagtube.fragments.songs.fragments.AlbumFragment;
import io.awesome.gagtube.fragments.songs.fragments.ArtistFragment;
import io.awesome.gagtube.fragments.songs.fragments.PlaylistFragment;
import io.awesome.gagtube.fragments.songs.fragments.SongFragment;

public class SongsPagerAdapter extends FragmentStateAdapter {

    public SongsPagerAdapter(FragmentManager fm, Lifecycle lifecycle) {
        super(fm, lifecycle);
    }

    @NonNull
    @Override
    public Fragment createFragment(int position) {
        switch (position) {
            case 0:
                return SongFragment.getInstance();
            case 1:
                return ArtistFragment.getInstance();
            case 2:
                return AlbumFragment.getInstance();
            case 3:
                return PlaylistFragment.getInstance();
            default:
                return new Fragment();
        }
    }

    @Override
    public int getItemCount() {
        return 4;
    }
}
